<?php

function _gui_menu ($data=null) {

	$ret =	"<div style=\"text-align: center; margin-left: 32px; margin-right: 32px; height: 22px;\">\n" .
		"\t<div style=\"float: left; background-color: transparent;\">\n" .
		"\t\t<ul id=\"navmenu-h\">\n";

	if (!empty($data)) {
		foreach ($data as $entry) {
			$ret .=	"\t\t\t<li>\n" .
				"\t\t\t\t<a href=\"" . $entry['url'] . "\">" . $entry['name'] . "</a>\n" .
				"\t\t\t</li>\n";
		}
	}


	$ret .= "\t\t</ul>\n" .
		"\t</div>\n" .
		"\t<div style=\"float: right;\">\n" .
		"\t\t<ul id=\"navmenu-h\">\n" .
		"\t\t\t<li>\n" .
		"\t\t\t\t<a href=\"/userapp/\">UserApp Management</a>\n" .
		"\t\t\t</li>\n " .
		"\t\t\t<li>\n" .
		"\t\t\t\t<a href=\"/app/berogui/\">beroGUI</a>\n" .
		"\t\t\t</li>\n " .
		"\t\t</ul>\n" .
		"\t</div>\n" .
		"</div>\n";

	return($ret);
}

function gui_header ($title, $menu_data=null) {

	$bg_inc = '/app/berogui/includes';

	$ret =	"<xml version=\"1.0\" encoding=\"UTF-8\">\n" .
		"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n" .
		"\t\"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n" .
		"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n" .
		"\t<head>\n" .
		"\t\t<title>" . $title . "</title>\n" .
		"\t\t<link type=\"text/css\" rel=\"stylesheet\" href=\"/userapp/css/beroApp.css\" />\n" .
		"\t\t<link rel=\"icon\" type=\"image/x-icon\" href=\"" . $bg_inc . "/images/favicon.ico\" />\n" .
		"\t</head>\n" .
		"\t<body>\n" .
		"\t\t<div class=\"main\">\n" .
		"\t\t\t<div class=\"top\">\n" .
		"\t\t\t\t<img src=\"" . $bg_inc . "/images/bg_top.png\" />\n" .
		"\t\t\t</div>\n" .
		"\t\t\t<div class=\"left\">\n" .
		"\t\t\t\t<img src=\"" . $bg_inc . "/images/berofixlogo.png\" />\n" .
		"\t\t\t\t<div style=\"width: 100%; text-align: center;\">\n" .
		"\t\t\t\t\t<hr style=\"height: 2px; color: gray; margin-bottom: 20px;\" />\n" .
		"\t\t\t\t\t<span style=\"background-color: transparent; color: gray; font-size: 30px;\">" . $title . "</span>\n" .
		"\t\t\t\t</div>\n" .
		"\t\t\t\t<br /><br />\n" .
		_gui_menu($menu_data) .
		"\t\t\t\t<br /><br />\n" .
		"\t\t\t\t<div class=\"content\">\n";

	return($ret);
}

function gui_footer () {

	$bg_inc = '/app/berogui/includes';

	$ret =	"\t\t\t\t</div>\n" .
		"\t\t\t\t<div style=\"width: 100%; text-align: right;\">\n" .
		"\t\t\t\t\t<hr style=\"height: 2px; color: gray;\" />\n" .
		"\t\t\t\t\t<a href=\"http://www.beronet.com/\">\n" .
		"\t\t\t\t\t\t<img src=\"" . $bg_inc . "/images/beroLogo.gif\" style=\"border: 0px;\" />\n" .
		"\t\t\t\t\t</a>\n" .
		"\t\t\t\t</div>\n" .
		"\t\t\t</div>\n" .
		"\t\t\t<div class=\"bottom\">\n" .
		"\t\t\t\t<img src=\"" . $bg_inc . "/images/bg_bottom.png\" />\n" .
		"\t\t\t</div>\n" .
		"\t\t</div>\n" .
		"\t</body>\n" .
		"</html>\n";

	return($ret);
}

?>
